



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>浅谈Async/Await</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">浅谈Async/Await</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 23:49:46 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>概要</h3>
<p>在很长一段时间里面，FE们不得不依靠回调来处理异步代码。使用回调的结果是，代码变得很纠结，不便于理解与维护，值得庆幸的是Promise带来了.then()，让代码变得井然有序，便于管理。于是我们大量使用，代替了原来的回调方式。但是不存在一种方法可以让当前的执行流程阻塞直到promise完成。JS里面，我们无法直接原地等promise完成，唯一可以用于提前计划promise完成后的执行逻辑的方式就是通过then附加回调函数。 现在随着Async/Await的增加，可以让接口按顺序异步获取数据，用更可读，可维护的方式处理回调。</p>
<h3>What Is Async/Await</h3>
<p>Async/Await是一个期待已久的JavaScript特性，让我们更好的理解使用异步函数。它建立在Promises上，并且与所有现有的基于Promise的API兼容。那么下面我来学习下这两个函数吧，lets go~</p>
<p>1、Async—声明一个异步函数(async function someName(){...})</p>
<blockquote><ul><li>自动将常规函数转换成Promise，返回值也是一个Promise对象</li>
<li>只有async函数内部的异步操作执行完，才会执行then方法指定的回调函数</li>
<li>异步函数内部可以使用await</li></ul></blockquote>
<p>2、Await—暂停异步的功能执行(var result = await someAsyncCall();)</p>
<blockquote><ul><li>放置在Promise调用之前，await强制其他代码等待，直到Promise完成并返回结果</li>
<li>只能与Promise一起使用，不适用与回调</li>
<li>只能在async函数内部使用</li></ul></blockquote>
<p>3、使用小贴士：async函数完全可以看作多个异步操作，包装成的一个 Promise 对象，而await命令就是内部then命令的语法糖。</p>
<h3>How To Use Async/Await</h3>
<p>如何来用呢？我们一起来敲一敲代码吧~</p>
<p>1、async 函数的几种使用形式</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1203274/201712/1203274-20171228194352053-73847335.png"></p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1203274/201712/1203274-20171228194400819-797466460.png"></p>
<p>2、await的用法则相对简单了许多，他后面需要是一个Promise对象，如果不是则会被转成Promise对象。只要其中一个如果Promise对象变为reject状态，那么整个async函数都会中断操作。如果状态是resolve，那么他的返回值则会变成then里面的参数，如下。</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1203274/201712/1203274-20171228194410491-2094916683.png"></p>
<p>3、使用小贴士</p>
<blockquote><ul><li>怎样容错呢，犹豫await后面的promise运行结果可能是rejected，最好把await放入try{}catch{}中</li>
<li>Await后的异步操作，如果彼此没有依赖关系最好同时触发，在下面场景一会有介绍</li>
<li>Await只能在async函数之中，如果在普通函数中，会报错</li></ul></blockquote>
<h3>使用场景介绍</h3>
<p>那么什么情况下适合用，什么情况下不适合使用呢？</p>
<p>1、场景一，我们同时发出三个不互相依赖的请求，如果用Async/Await就显得不明智了</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1203274/201712/1203274-20171228194420116-1635859807.png"></p>
<p>如上图所示，上面我们A需要2s，B需要4s，C需要3s，我们如上图所示发请求，就存在彼此依赖的关系，c等b执行完，b等a执行完，从开始到结束需要（2+3+4）9s。</p>
<p>此时我们需要用Promise.all()将异步调用并行执行，而不是一个接一个执行，如下所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1203274/201712/1203274-20171228194427928-1570870023.png"></p>
<p>这样将会节省我们不少的时间，从原来的的9s缩减到4s，是不是很开心，耶~</p>
<p>2、场景二，我曾经遇到过一个场景，一个提交表单的页面，里面有姓名、地址等巴拉巴拉的信息，其中有一项是手机验证码，我们不得不等待手机验证码接口通过，才能发出后续的请求操作，这时候接口之间就存在了彼此依赖的关系，Async跟Await就有了用武之地，让异步请求之间可以按顺序执行。</p>
<p>其中不用Async/Await的写法，我们不得不用.then()的方式，在第一个请求验证码的接口有返回值之后，才能执行后续的的Promise，并且还需要一个then输出结果，如下图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1203274/201712/1203274-20171228194435897-1093208265.png"></p>
<p>而用Async/Await的方式去写就是下面这样，我们将逻辑分装在一个async函数里。这样我们就可以直接对promise使用await了，也就规避了写then回调。最后我们调用这个async函数，然后按照普通的方式使用返回的promise。要记得容错呢~~</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1203274/201712/1203274-20171228194442975-656553723.png"></p>
<p>以上是两个模拟简单的场景，为的是让大家容易理解Async/Await的使用，那么接下来我们看看兼容性吧~</p>
<h3>兼容性</h3>
<p>Async / Await已经在大多数主流浏览器中可用。</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1203274/201712/1203274-20171228194451131-749103913.png"></p>
<h3>小结</h3>
<p>Async/Await让我们用少量的代码来使用Promise，我们可以将一些有依赖关系的回调函数的处理逻辑放在async里面，然后在非async的区域使用，这样可以减少then或者catch回调。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlmkl69.html">python学习7</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gmoo49.html">DEDEcms  在php5&period;4以上 后台登录空白解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq43owj8.html">【循序渐进学Python】14&period;数据库的支持</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k36m6q.html">数据库&period;mdf</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1gd3d9.html">函数式编程之block</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdd2xm8.html">Android中visibility属性VISIBLE、INVISIBLE、GONE的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xje2n9.html">新版本 JSAPI微信支付V3 C&num; DEMO</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ym0z3q.html">如何设置box shadow的透明度</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v43338.html">（转）Qt Model&sol;View 学习笔记 &lpar;七&rpar;&mdash;&mdash;Delegate类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmx44k9.html">（转载）Delphi开发经验谈</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z12o739.html">java web -部署在linux</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j4nm38.html">sqlserver登录名权限和用户名权限语句设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k1xv09.html">Bootstarp  使用布局</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzw7ne8.html">微信小程序（一），授权页面搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mzod48.html">MapReduce shuffle过程剖析及调优</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ww6xzq.html">Java 中初始化 List 集合的 6 种方式&excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjlne39.html">Study 3 &mdash;&mdash; 表格</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w45mzq.html">linux网络操作 配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv26ezx9.html">&lbrack;Shell&rsqb;一张图知道Shell（图）</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1dezk9.html">使用virtualenv在ubuntu上搭建python 3开发环境</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pd2oxy9.html">Ext3和Ext4文件系统区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgk2wm8.html">JavaScript数据可视化编程学习（二）Flotr2，雷达图</a>
			</li>
						<li><a href="https://www.batexi.com/a/9507e268.html">Java面试之框架篇&lpar;八&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z301j9.html">ssh、scp免秘钥远程执行命令：expect</a>
			</li>
						<li><a href="https://www.batexi.com/a/95072zz8.html">《java&period;util&period;concurrent 包源码阅读》05 BlockingQueue</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ygezg8.html">SQL测试题</a>
			</li>
						<li><a href="https://www.batexi.com/a/95075oe8.html">vue搭建环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk4wee8.html">企业级分布式监控系统-Zabbix基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjlmpj8.html">&lbrack;行业关键词&rsqb; review code review</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zjx6j9.html">php数据库备份脚本</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
